﻿Type=Class
Version=4
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Public Sub Class_Globals
	Public bp As BitmapPlus
	Public bmp As Bitmap
	Public ivRotatKnob As ImageView
	Public MaxAngle As Int
	MaxAngle = 360

	Public Angle, OldAngle As Int
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(rrg As Boolean,tag As Int)
 	'bmp.Initialize (File.DirAssets, "cat.png")						BMP IS SUPPOSE THE ARRAY IMAGE LOAD IN MAIN MODULE

	'ivRotatKnob.Initialize("")
	'ivRotatKnob.SetBackgroundImage(bmp)
	'Activity.AddView(ivRotatKnob, 60dip, 34dip, 100%x, 100%y)      THIS ARE THE ARRAY IMAGE ADDED IN IMAGEVIEW
	
	Dim r As Reflector
	r.Target = ivRotatKnob									'iVROTATKNOB IS THE SPECIFIC VALUE GET FROM THE ARRAY
	r.SetOnTouchListener("Knob_Touch")
End Sub
Private Sub getAngle(X As Float, Y As Float) As Float
	Dim dx, dy As Float
   dx = (ivRotatKnob.Width / 2) - X
   dy = Y - (ivRotatKnob.Height / 2)
	Return ATan2(-dx, -dy) / cPI * 180
End Sub

Sub CalcAngle(X As Float, Y As Float)
	Dim NewAngle As Float
	NewAngle = getAngle(X, Y)
	Dim Delta, Delta1, Delta2, Delta3 As Float
	Delta1 = NewAngle - OldAngle
	Delta2 = NewAngle - OldAngle + 360
	Delta3 = NewAngle - OldAngle - 360
	' What's the shortest distance between the old and new angles ?
	If Abs(Delta1) < Abs(Delta2) AND Abs(Delta1) < Abs(Delta3) Then
		Delta = Delta1
	Else If Abs(Delta2) < Abs(Delta3) Then
		Delta = Delta2
	Else
		Delta = Delta3
	End If
	Angle = Max(MaxAngle, Max(Angle + Delta, MaxAngle))
	OldAngle = NewAngle
End Sub

Sub Knob_Touch(ViewTag As Object, Action As Int, X As Float, Y As Float, MotionEvent As Object) As Boolean
Log("ME - " & Action)
'Log("Last View Touched - " & LastObj)
	Select Action
		Case 0 ' DOWN
			'LastObj = ivRotatKnob
				OldAngle = getAngle(X, Y)
				ivRotatKnob.SetBackgroundImage(bp.Rotate(bmp, bmp.Width, bmp.Height, Angle, True))
'		Case 1 ' UP
'				ivRotatKnob.SetBackgroundImage(bp.Rotate(bmp,bmp.Width, bmp.Height, Angle, True))
		Case 2 ' MOVE
			CalcAngle(X, Y)
				ivRotatKnob.SetBackgroundImage(bp.Rotate(bmp, bmp.Width, bmp.Height, Angle, True))
	End Select
	Return True
End Sub